import java.util.Vector;

public class Baldes {
	private No local;
	private Vector<No> visitados;
	private Vector<No> abertos;

	public Baldes() {
		local = new No(null);
		visitados = new Vector<No>();
		visitados.add(local);
		abertos = new Vector<No>();
		abertos.add(local);
	}

	public void setObjetivo(int a, int b) {
		local.setObjetivo(a, b);
	}

	public void run(int metodo) {
		switch (metodo) {
		case 0:
			subidaEncostaSimples();
			break;
		case 1:
			subidaTrilhaIngreme();
			break;
		case 2:
			melhorEscolha();
			break;
		}
	}

	public void verificaVisitados(No no) {
		No aux = no.getPai();
		while (aux != null) {
			if (no.getBaldeA() == aux.getBaldeA()) {
				if (no.getBaldeB() == aux.getBaldeB()) {
					no.fechar();
				}
			}
			aux = aux.getPai();
		}
	}

	public void subidaEncostaSimples() {
		System.out.println("SUBIDA DE ENCOSTA SIMPLES\n\n");
		int interacoes = 0;
		boolean sair = false;
		while (!sair) {
			sair = local.getPontos() == No.getObjetivo();
			if (!sair) {
				System.out.println("*** " + (interacoes + 1)
						+ "a INTERACAO ***");
				local.mostrar();
				System.out
						.println("---> Tenta encontrar um filho melhor que o No local");
				int indiceFilho = 0;
				boolean achouMelhor = false;
				while ((!achouMelhor) && (indiceFilho < No.MAXFILHOS)) {
					No filho = local.getFilho(indiceFilho);
					verificaVisitados(filho);
					if (!filho.estaFechado()) {
						No.mostrarRegra(indiceFilho);
						filho.mostrar();
						if (filho.melhorQue(local)) {
							local = filho;
							visitados.add(local);
							achouMelhor = true;
						}
					}
					indiceFilho++;
				}
				if (!achouMelhor) {
					System.out
							.println("---> Nao encontrou, Pega o melhor dos filhos.");
					indiceFilho = 0;
					No melhorFilho = null;
					for (int i = 0; i < No.MAXFILHOS; i++) {
						No filho = local.getFilho(i);
						if (!filho.estaFechado()) {
							if (!achouMelhor) {
								melhorFilho = filho;
								indiceFilho = i;
								achouMelhor = true;
							} else {
								if (filho.melhorQue(melhorFilho)) {
									melhorFilho = filho;
									indiceFilho = i;
									achouMelhor = true;
								}
							}
						}
					}
					if (achouMelhor) {
						local = melhorFilho;
						visitados.add(local);
						local.mostrar();
						No.mostrarRegra(indiceFilho);
					}
				}
				if (!achouMelhor) {
					System.out.println("<--- BACKTRACKING");
					local.fechar();
					No aux = local.getPai();
					visitados.remove(local);
					local = aux;
					if (local == null) {
						sair = true;
						System.out.println("\n. . . NAO EXISTE SOLUCAO . . .");
					}
				}
				System.out.println();
			}
			interacoes++;
		}
		System.out.println("\nINTERACOES: " + (interacoes - 1));

		System.out.println("\n...CAMINHO EFETUADO...:");
		for (int i = 0; i < visitados.size(); i++) {
			visitados.get(i).mostrar();
		}
	}

	public void subidaTrilhaIngreme() {
		System.out.println("SUBIDA DE ENCOSTA PELA TRILHA MAIS INGREME\n\n");
		int interacoes = 0;
		boolean sair = false;
		while (!sair) {
			sair = local.getPontos() == No.getObjetivo();
			if (!sair) {
				System.out.println("*** " + (interacoes + 1)
						+ "a INTERACAO ***");
				local.mostrar();
				System.out.println("---> Pega o melhor dos filhos.");
				No melhorFilho = null;
				int indiceFilho = 0;
				boolean achouMelhor = false;
				for (int i = 0; i < No.MAXFILHOS; i++) {
					No filho = local.getFilho(i);
					verificaVisitados(filho);
					if (!filho.estaFechado()) {
						if (!achouMelhor) {
							melhorFilho = filho;
							indiceFilho = i;
							achouMelhor = true;
						} else {
							if (filho.melhorQue(melhorFilho)) {
								melhorFilho = filho;
								indiceFilho = i;
								achouMelhor = true;
							}
						}
					}
				}
				if (achouMelhor) {
					local = melhorFilho;
					visitados.add(local);
					local.mostrar();
					No.mostrarRegra(indiceFilho);
				}
				// 3. Se nao encontrou nada, entao faz backtracking
				if (!achouMelhor) {
					System.out.println("<--- BACKTRACKING");
					local.fechar();
					No aux = local.getPai();
					visitados.remove(local);
					local = aux;
					if (local == null) {
						sair = true;
						System.out.println("\n. . . NAO EXISTE SOLUCAO . . .");
					}
				}
				System.out.println();
			}
			interacoes++;
		}
		System.out.println("\nINTERACOES: " + (interacoes - 1));

		System.out.println("\n...CAMINHO EFETUADO...:");
		for (int i = 0; i < visitados.size(); i++) {
			visitados.get(i).mostrar();
		}
	}

	public void melhorEscolha() {
		System.out.println("MELHOR ESCOLHA - A*\n\n");
		int interacoes = 0;
		boolean sair = false;
		while (!sair) {
			sair = local.getPontos() == No.getObjetivo();
			if (!sair) {
				System.out.println("*** " + (interacoes + 1)
						+ "a INTERACAO ***");
				local.mostrar();
				System.out.println("---> Abre todos os filhos do No local");
				for (int i = 0; i < No.MAXFILHOS; i++) {
					No filho = local.getFilho(i);
					verificaVisitados(filho);
					if (!filho.estaFechado()) {
						abertos.add(filho);
						filho.mostrar();
						filho.mostrarRegraEfetuada();
					}
				}
				abertos.remove(local);
				System.out.println("---> Pega o melhor No aberto.");
				local = null;
				for (int i = 0; i < abertos.size(); i++) {
					if (local == null) {
						local = abertos.get(i);
						local.mostrar();
					} else {
						No filho = abertos.get(i);
						filho.mostrar();
						if (filho.melhorQue(local)) {
							local = filho;
						} else if (filho.getPontos() == local.getPontos()) {
							// Se iguais, pega o de menor nivel
							if (filho.getNivel() < local.getNivel()) {
								local = filho;
							}
						}
					}
				}
				System.out.println("---> No escolhido");
				if (local != null) {
					local.mostrar();
				} else {
					sair = true;
				}
				System.out.println();
			}
			interacoes++;
		}
		System.out.println("\nINTERACOES: " + (interacoes - 1));

		// Constroi o caminho efetuado
		visitados.clear();
		No aux = local;
		while (aux != null) {
			visitados.add(0, aux);
			aux = aux.getPai();
		}

		System.out.println("\n...CAMINHO EFETUADO...:");
		for (int i = 0; i < visitados.size(); i++) {
			visitados.get(i).mostrar();
		}
		if (local == null) {
			System.out.println("\n. . . NAO EXISTE SOLUCAO . . .");
		}
	}

	public static void main(String[] arguments) {
		if (arguments.length == 3) {
			int metodo = Integer.parseInt(arguments[0]);
			Baldes baldes = new Baldes();
			baldes.setObjetivo(Integer.parseInt(arguments[1]), Integer
					.parseInt(arguments[2]));
			baldes.run(metodo);
		} else {
			System.out
					.println("Utilize: java Baldes <metodo> <objetivo Balde A> <objetivo Balde B>");
			System.out.println("metodos:");
			System.out.println("   0 : Subida de Encosta Simples");
			System.out.println("   1 : Subida de Encosta Pela Trilha Ingreme");
			System.out.println("   2 : Melhor Escolha (A*)");
			System.out.println("\nExemplo: java Baldes 0 0 2");
			System.out
					.println("Executa o algoritmo 0 para conseguir 0 litros no balde A e 2 no balde B");
		}
	}
}
