public class No {
	private No pai;
	private int nivel;
	private int baldeA;
	private int baldeB;
	private int objetivoBaldeA;
	private int objetivoBaldeB;
	private int regraEfetuada;
	private boolean fechado;
	private No filho[];
	public static int MAXBALDEA = 4;
	public static int MAXBALDEB = 3;
	private static int OBJETIVO = 0;
	public static int MAXFILHOS = 6;

	public No(No noPai) {
		pai = noPai;
		fechado = false;
		regraEfetuada = -1;
		if (pai != null) {
			nivel = pai.getNivel() + 1;
			baldeA = pai.getBaldeA();
			baldeB = pai.getBaldeB();
			objetivoBaldeA = pai.objetivoBaldeA;
			objetivoBaldeB = pai.objetivoBaldeB;
		} else {
			nivel = 0;
			baldeA = 0;
			baldeB = 0;
			objetivoBaldeA = 0;
			objetivoBaldeB = 2;
		}
		filho = new No[MAXFILHOS];
		for (int i = 0; i < MAXFILHOS; i++) {
			filho[i] = null;
		}
	}

	public void setObjetivo(int a, int b) {
		if ((a >= 0) && (a <= MAXBALDEA)) {
			objetivoBaldeA = a;
		}
		if ((b >= 0) && (b <= MAXBALDEB)) {
			objetivoBaldeB = b;
		}
	}

	public int getNivel() {
		return nivel;
	}

	public int getBaldeA() {
		return baldeA;
	}

	public int getBaldeB() {
		return baldeB;
	}

	public int getPontos() {
		int auxA = objetivoBaldeA - baldeA;
		if (auxA < 0) {
			auxA *= -1;
		}
		int auxB = objetivoBaldeB - baldeB;
		if (auxB < 0) {
			auxB *= -1;
		}
		return (auxA + auxB);
	}

	public No getPai() {
		return pai;
	}

	public boolean estaFechado() {
		return fechado;
	}

	public boolean melhorQue(No no) {
		boolean aux = false;
		if (getPontos() < no.getPontos()) {
			aux = true;
		}
		return aux;
	}

	public void fechar() {
		fechado = true;
	}

	public static int getObjetivo() {
		return OBJETIVO;
	}

	public No getFilho(int indice) {
		No no = null;
		if ((indice >= 0) && (indice < MAXFILHOS)) {
			if (filho[indice] == null) {
				filho[indice] = new No(this);
				boolean aux = false;
				switch (indice) {
				case 0:
					aux = filho[indice].encherBaldeA();
					break;
				case 1:
					aux = filho[indice].esvaziarBaldeA();
					break;
				case 2:
					aux = filho[indice].encherBaldeB();
					break;
				case 3:
					aux = filho[indice].esvaziarBaldeB();
					break;
				case 4:
					aux = filho[indice].jogarAemB();
					break;
				case 5:
					aux = filho[indice].jogarBemA();
					break;
				}
				filho[indice].regraEfetuada = indice;
				if (!aux) {
					filho[indice].fechar();
				}
			}
			no = filho[indice];
		}
		return no;
	}

	/*
	 * Regras
	 */

	public boolean encherBaldeA() {
		if (baldeA < MAXBALDEA) {
			baldeA = MAXBALDEA;
			return true;
		}
		return false;
	}

	public boolean esvaziarBaldeA() {
		if (baldeA > 0) {
			baldeA = 0;
			return true;
		}
		return false;
	}

	public boolean encherBaldeB() {
		if (baldeB < MAXBALDEB) {
			baldeB = MAXBALDEB;
			return true;
		}
		return false;
	}

	public boolean esvaziarBaldeB() {
		if (baldeB > 0) {
			baldeB = 0;
			return true;
		}
		return false;
	}

	public boolean jogarAemB() {
		int falta = MAXBALDEB - baldeB;
		int transferir = baldeA;
		if (baldeA > falta) {
			transferir = falta;
		}
		if (transferir > 0) {
			baldeA -= transferir;
			baldeB += transferir;
			return true;
		}
		return false;
	}

	public boolean jogarBemA() {
		int falta = MAXBALDEA - baldeA;
		int transferir = baldeB;
		if (baldeB > falta) {
			transferir = falta;
		}
		if (transferir > 0) {
			baldeB -= transferir;
			baldeA += transferir;
			return true;
		}
		return false;
	}

	/*
	 * Apresentacao
	 */

	public void mostrarRegraEfetuada() {
		if (regraEfetuada >= 0) {
			No.mostrarRegra(regraEfetuada);
		}
	}

	public void mostrar() {
		System.out.print("* [ " + baldeA + " , " + baldeB + " | " + getPontos()
				+ " ]");
		if (regraEfetuada >= 0) {
			System.out.print(" - R." + regraEfetuada);
		} else {
			System.out.print("      ");
		}
		System.out.println("  (" + nivel + ")");
	}

	public static void mostrarRegra(int indice) {
		switch (indice) {
		case 0:
			System.out.println("-> R0 : Encher Balde A");
			break;
		case 1:
			System.out.println("-> R1 : Esvaziar Balde A");
			break;
		case 2:
			System.out.println("-> R2 : Encher Balde B");
			break;
		case 3:
			System.out.println("-> R3 : Esvaziar Balde B");
			break;
		case 4:
			System.out.println("-> R4 : Jogar conteudo de A em B");
			break;
		case 5:
			System.out.println("-> R5 : Jogar conteudo de B em A");
			break;
		}
	}
}
